import React from 'react';
import { FatherInfo } from './components/type/list';
import { MergedSchema } from './context/mergeSchema';
import { ShortLevel } from './definition/definitions';
export interface FieldProps {
    viewport: string;
    route: string[];
    field?: string;
    fatherInfo?: FatherInfo;
    schemaEntry?: string | undefined;
    short?: ShortLevel;
    canNotRename?: boolean | undefined;
    rootMenuItems?: JSX.Element[];
    data?: any;
    reRender?: any;
}
export interface IField {
    valueEntry: string | undefined;
    mergedEntrySchema: MergedSchema | false;
    mergedValueSchema: MergedSchema | false;
    ofOption: string | false | null;
    errors: any[];
    id: string;
}
/**
 * 注意，如果一个组件使用自己且使用 react-redux 链接，请注意使用connect后的名字！
 */
export declare const Field: import("react-redux").ConnectedComponent<React.MemoExoticComponent<(props: FieldProps) => JSX.Element>, {
    viewport: string;
    short?: ShortLevel | undefined;
    schemaEntry?: string | undefined;
    field?: string | undefined;
    route: string[];
    fatherInfo?: FatherInfo | undefined;
    canNotRename?: boolean | undefined;
    rootMenuItems?: JSX.Element[] | undefined;
    reRender?: any;
    data?: any;
    context?: React.Context<import("react-redux").ReactReduxContextValue<any, import("redux").AnyAction>> | undefined;
    store?: import("redux").Store<any, import("redux").AnyAction> | undefined;
}>;
