import React, { useRef } from 'react';
import { jsonDataType } from "../../utils/utils";
export var useEditionComponent = function useEditionComponent(ctx, fieldProps, fieldInfo) {
  var data = fieldProps.data;
  var mergedValueSchema = fieldInfo.mergedValueSchema;
  var _ref = mergedValueSchema || {},
    constValue = _ref.const,
    enumValue = _ref.enum,
    _ref$view = _ref.view,
    _ref$view2 = _ref$view === void 0 ? {} : _ref$view,
    _ref$view2$type = _ref$view2.type,
    valueEntryViewType = _ref$view2$type === void 0 ? undefined : _ref$view2$type;
  var dataType = jsonDataType(data);
  var valueType = constValue !== undefined ? 'const' : enumValue !== undefined ? 'enum' : dataType;
  var _ref2 = mergedValueSchema || {},
    format = _ref2.format;
  var ref = useRef();

  // 设置值组件
  var EditionComponent = valueType === 'string' && format ? ctx.getFormatComponent(valueEntryViewType, format) : ctx.getComponent(valueEntryViewType, ['edition', valueType]);
  var editionInfo = {
    valueType: valueType,
    viewType: valueEntryViewType,
    format: format
  };
  return [/*#__PURE__*/React.createElement(EditionComponent, {
    fieldProps: fieldProps,
    ctx: ctx,
    fieldInfo: fieldInfo,
    key: 'edition',
    ref: ref
  }), ref, editionInfo];
};