import { CpuEditorContext } from '../../context/CpuEditorContext';
import { ShortLevel } from '../../definition/definitions';
import { IField } from '../../Field';
/**
 * 原则上来自于父字段的信息，不具有子字段特异性
 */
export interface FatherInfo {
    type: string;
    length?: number;
    required?: string[];
    schemaEntry: string | undefined;
    valueEntry: string | undefined;
}
export interface ChildData {
    key: string;
    value: any;
}
/**
 * 空的数组/对象子项数据，用作 create 组件
 */
export interface EmptyChildData {
    key: string;
}
export interface FieldDisplayList {
    short: ShortLevel;
    items: (ChildData | EmptyChildData)[];
}
export interface ListDisplayPanelProps {
    ctx: CpuEditorContext;
    viewport: string;
    lists: FieldDisplayList[];
    fatherInfo: FatherInfo;
    fieldInfo: IField;
    data: any;
    access: string[];
    domAttributes?: Record<string, string>;
    id: string;
}
export declare const childDataNotEmpty: (data: ChildData | EmptyChildData) => data is ChildData;
