function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e2) { throw _e2; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e3) { didErr = true; err = _e3; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
/* eslint-disable no-case-declarations */
import _ from 'lodash';
import { addRef } from "../utils/utils";
import { isShort, schemaIsShort } from "./virtual";
/**
 * 将 schemaMap 以合并的方式得到其中的参数
 * 1. first 还需要知道使用的 ref 在哪
 * 2. 对于对象或者数组的，值为 schema 的属性，需要一个子info来处理，也合到里面
 * @param ctx
 * @param map
 * @returns
 */
export var mergeSchemaMap = function mergeSchemaMap(ctx, map) {
  var result = {};
  var _iterator = _createForOfIteratorHelper(map),
    _step;
  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var _step$value = _slicedToArray(_step.value, 2),
        ref = _step$value[0],
        schema = _step$value[1];
      if (_typeof(schema) === 'object') {
        for (var key in schema) {
          if (Object.prototype.hasOwnProperty.call(schema, key)) {
            // acts different by key
            var value = schema[key];
            switch (key) {
              case 'type':
                // intersection
                var typeValue = value instanceof Array ? value : [value];
                result[key] = result[key] ? _.intersection(result[key], typeValue) : typeValue;
                if (result[key].length === 0) return false;
                break;
              case 'properties':
              case 'patternProperties':
                // mergeRef
                if (!result[key]) result[key] = {};
                for (var propKey in value) {
                  if (Object.prototype.hasOwnProperty.call(value, propKey) && !result[key][propKey]) {
                    var propRef = addRef(ref, key, propKey);
                    result[key][propKey] = propRef;
                  }
                }
                break;
              case 'required':
                // union
                result[key] = result[key] ? _.union(result[key], value) : value;
                break;
              case 'dependencies':
                // merge ref/array
                if (!result[key]) result[key] = {};
                for (var _propKey in value) {
                  if (Object.prototype.hasOwnProperty.call(value, _propKey) && !result[key][_propKey]) {
                    var depValue = value[_propKey];
                    if (depValue instanceof Array) {
                      result[key][_propKey] = depValue;
                    } else {
                      var _propRef = addRef(ref, key, _propKey);
                      result[key][_propKey] = _propRef;
                    }
                  }
                }
                break;
              case 'prefixItems':
                // array to Refs
                result[key] = {
                  length: value.length,
                  ref: addRef(ref, key)
                };
                break;
              case 'items':
                // to item Ref/array to prefix Refs
                if (!result[key]) {
                  if (value instanceof Array) {
                    result['prefixItems'] = {
                      length: value.length,
                      ref: addRef(ref, key)
                    };
                  } else {
                    result[key] = value ? addRef(ref, key) : false;
                  }
                }
                break;
              case 'additionalItems':
                // 旧版本 additionalItems => items
                result['items'] = value ? addRef(ref, key) : false;
                break;
              case 'additionalProperties':
                // toRef
                result[key] = value ? addRef(ref, key) : false;
                break;
              case 'oneOf':
              case 'anyOf':
                // SchemaArrayRefInfo
                if (!result[key]) {
                  result[key] = {
                    length: value.length,
                    ref: addRef(ref, key)
                  };
                }
                break;
              default:
                // first: no ref involved
                if (!result[key]) {
                  result[key] = value;
                }
                break;
            }
          }
        }
      } else if (schema === false) return false;
    }
    // post-process: update virtual attributes
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
  result[isShort] = schemaIsShort(ctx, result);
  return result;
};