import { JSONSchema } from '../type/Schema';
import { CpuEditorContext } from './CpuEditorContext';
export interface ofSchemaCache {
    ofRef: string;
    ofLength: number;
    subOfRefs: (undefined | string)[];
    options: any[];
}
/**
 * 验证数据符合 oneOf/anyOf 的哪一个选项
 * @param data
 * @param schemaEntry
 * @param ctx
 * @returns `null`为无 oneOf/anyOf，`false`为不符合任何选项，`string`为选项链
 */
export declare const getOfOption: (data: any, schemaEntry: string, ctx: CpuEditorContext) => string | null | false;
/**
 * 通过 of 链找到 schema 经层层选择之后引用的 valueEntry
 * @param ctx
 * @param schemaEntry
 * @param ofChain
 */
export declare const getRefByOfChain: (ctx: CpuEditorContext, schemaEntry: string, ofChain: string) => string;
/**
 * 对 `schemaEntry` 设置 ofInfo
 * @param ctx
 * @param schemaEntry
 * @param rootSchema
 * @param nowOfRefs
 * @returns
 */
export declare const setOfInfo: (ctx: CpuEditorContext, schemaEntry: string, rootSchema: JSONSchema, nowOfRefs?: string[]) => {
    subOfRefs: (string | undefined)[];
    ofRef: string;
    ofLength: number;
    options: any[];
} | null;
