import { FatherInfo } from '../components/type/list';
import { CpuEditorContext } from '../context/CpuEditorContext';
import { FieldProps, IField } from '../Field';
/**
 * 通过 schema 判断当前 json 是否可以创建新的属性。
 * @param props
 * @param fieldInfo
 */
export declare const canFieldCreate: (data: any, fieldInfo: IField) => boolean | string[];
/**
 * 通过 schema 判断该字段(来自一个对象)是否可以重新命名
 * @param ctx
 * @param props
 * @param fieldInfo
 * @returns 返回字符串为不可命名(同时其也是字段名称)，返回正则为命名范围，返回空串即可命名
 */
export declare const canFieldRename: (ctx: CpuEditorContext, props: FieldProps, fieldInfo: IField) => string | RegExp;
/**
 * 通过 schema 判断该字段是否可删除。可删除条件：
 * 1. `field === undefined` 意味着根字段，不可删除
 * 2. 如果父亲是数组，只要不在数组 prefixItems 里面即可删除
 * 3. 如果父亲是对象，只要不在 required 里面即可删除
 *
 * @param ctx
 * @param props
 */
export declare const canFieldDelete: (ctx: CpuEditorContext, props: FieldProps) => boolean;
/**
 * 字段是否为 required 字段
 * @param field
 * @param fatherInfo
 * @returns
 */
export declare const isFieldRequired: (field: string | undefined, fatherInfo?: FatherInfo | undefined) => boolean;
