import { MergedSchema } from '../context/mergeSchema';
import { JSONSchema } from '../type/Schema';
/**
 * 找到 $ref 引用的 schemaMap。如果找不到返回一个空 Map
 * @param $ref json-pointer with #
 * @param rootSchema
 * @param deepSearch 深入搜索：深递归加入所有schema引用，否则只递归到浅一层
 * @returns
 */
export declare const getRefSchemaMap: ($ref: string | undefined | string[], rootSchema?: {}, deepSearch?: boolean) => Map<string, JSONSchema | boolean>;
/**
 * 找到 schemaMap 中所有含有某键的 uri 引用
 * @param schemaMap
 * @param k
 * @param all 是否拿到所有 ref ，默认只拿第一个
 * @param add 返回的ref是否加入属性名称，默认加入
 * @returns
 */
/**
 * 对 Array/Object 获取特定字段 schemaEntry。
 * 注意：
 * 1. 无论这其中有多少条 ref，一定保证给出的 schemaEntry 是从 `properties, patternProperties, additionalProperties, prefixItems, items` 这五个字段之一进入的。
 * 2. 只要给出的 ref 不是 undefined，一定能够找到对应的 schema
 * @param data 当前的 data
 * @param valueEntry
 * @param mergedValueSchema
 * @param field
 * @returns 对应子字段的 schemaEntry，结果为 false 代表对应 schema 为 false，在模式支持上当作 undefined 处理即可
 */
export declare const getFieldSchema: (data: any, valueEntry: string | undefined, mergedValueSchema: MergedSchema | false, field: string) => string | false | undefined;
